#include<bits/stdc++.h>
#define MAXN 2007
using namespace std;

int n,s;
int a[MAXN];

int dp[MAXN][20007];

int main(){
    
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>s>>n;
    for(int i=1;i<=n;i++){
        cin>>a[i];
    }

    for(int i=1;i<=s;i++)dp[0][i]=100000;
    dp[0][0]=0;

    for(int i=1;i<=n;i++){
        for(int f=0;f<=s;f++){
            if(a[i]>f)dp[i][f]=dp[i-1][f];
            else dp[i][f]=min(dp[i-1][f],dp[i][f-a[i]]+1);
        }
    }

    cout<<dp[n][s]<<"\n";

    return 0;
}
